## $Id: batching.py 14184 2016-09-23 16:38:53Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Batch processing for uniben documents.
"""
import grok
from waeup.ikoba.customers.batching import (
    CustomerProcessor,
    CustomerDocumentProcessorBase, ContractProcessorBase)
from ikobacustom.uniben.customers.interfaces import (
    IUnibenCustomer,
    IUnibenCustomerDocument, IRIAAContract)
from ikobacustom.uniben.interfaces import MessageFactory as _


class UnibenCustomerProcessor(CustomerProcessor):
    """A batch processor for ICustomer objects.
    """
    util_name = 'unibencustomerprocessor'
    grok.name(util_name)
    name = _('Uniben Customer Processor')
    iface = IUnibenCustomer


class UnibenCustomerPDFDocumentProcessor(CustomerDocumentProcessorBase):
    """A batch processor for IUnibenCustomerDocument objects.
    """
    util_name = 'unibencustomerpdfdocumentprocessor'
    grok.name(util_name)
    name = _('Uniben Customer PDF Document Processor')
    iface = IUnibenCustomerDocument
    factory_name = 'waeup.UnibenCustomerPDFDocument'


class RIAAContractProcessor(ContractProcessorBase):
    """A batch processor for IRIAAContract objects.
    """
    util_name = 'riaacontractprocessor'
    grok.name(util_name)
    name = _('RIAA Contract Processor')
    iface = IRIAAContract
    factory_name = 'waeup.RIAAContract'